<?php

// No direct access to this file
defined('_JEXEC') or die('Restricted access');

class OsmaModelAttrezzature extends JModelList {

    public function getItems() {
        $db = JFactory::getDBO();
        $query = $this->costruisciQuery();
        $db->setQuery($query, $this->limitstart, $this->limit);
        $results = $db->loadObjectList();
        return $results;
    }

    public function getTotal() {
        $db = JFactory::getDBO();
        $query = $this->costruisciQuery();
        $db->setQuery($query);
        $db->query();
        $results = $db->getNumRows();
        return $results;
    }

    protected function populateState($ordering = null, $direction = null) {
        $app = JFactory::getApplication('administrator');

        $search = $app->getUserStateFromRequest($this->context . '.filter.search', 'filter_search');
        $this->setState('filter.search', preg_replace('/\s+/', ' ', $search));
        parent::populateState('ordering', 'ASC');
    }

    public function __construct($config = array()) {
        $config['filter_fields'] = array(
            'ordering',
            'search'
        );
        parent::__construct($config);
        $mainframe = JFactory::getApplication();
        $this->limit = $mainframe->getUserStateFromRequest('global.list.limit', 'limit', $mainframe->getCfg('list_limit'), 'int');
        $this->limitstart = JRequest::getVar('limitstart', 0, '', 'int');
        $this->limitstart = ($this->limit != 0 ? (floor($this->limitstart / $this->limit) * $this->limit) : 0);

        $this->setState('limit', $this->limit);
        $this->setState('limitstart', $this->limitstart);
    }

    public function costruisciQuery() {

        $db = JFactory::getDBO();
        $query = $db->getQuery(true);

        $search = $db->escape($this->getState('filter.search'));

        $query->clear()->select("*")->from("#__osma_anagrafica_attrezzature")->where("deleted = 0")->order("tipologia ASC, marca ASC, modello ASC");

        if ($search) {
            $search = $db->quote('%' . $db->escape($search, true) . '%');

            $query->where("(marca LIKE " . $search . " OR modello LIKE " . $search . " OR tipologia LIKE " . $search . ")");
        }

        return $query;
    }

    function addAttrezzatureForm() {
        $db = JFactory::getDBO();
        $type = 2;

        $idAttrezzatura = JRequest::getVar("id");

        $query = "SELECT * FROM #__osma_anagrafica_attrezzature WHERE idAttrezzatura = " . $idAttrezzatura;

        $db->setQuery($query);
        $db->query();
        $data = $db->loadObject();

        include('components/com_osma/templates/addattrezzatura.php');
    }

    function pubblica() {
        $ids = JRequest::getVar("ids");
        $db = JFactory::getDBO();

        foreach ($ids AS $idAttrezzatura) {
            $query = "UPDATE #__osma_anagrafica_attrezzature SET published = 1 WHERE idAttrezzatura = " . $idAttrezzatura;
            $db->setQuery($query);
            $db->query();
        }
        return true;
    }

    function sospendi() {
        $ids = JRequest::getVar("ids");
        $db = JFactory::getDBO();

        foreach ($ids AS $idAttrezzatura) {
            $query = "UPDATE #__osma_anagrafica_attrezzature SET published=0 WHERE idAttrezzatura = " . $idAttrezzatura;
            $db->setQuery($query);
            $db->query();
        }
        return true;
    }

    function rimuovi() {
        $ids = JRequest::getVar("ids");
        $db = JFactory::getDBO();

        foreach ($ids AS $idAttrezzatura) {
            $query = "UPDATE #__osma_anagrafica_attrezzature SET deleted = 1 WHERE idAttrezzatura = " . $idAttrezzatura;
            $db->setQuery($query);
            $db->query();
        }
        return true;
    }

    function salva() {
        $db = JFactory::getDBO();

        $id = JRequest::getVar("id");

        $tipologia = JRequest::getVar("tipologia");
        $marca = JRequest::getVar("marca");
        $modello = JRequest::getVar("modello");
        $scadenzaRevisione = JRequest::getVar("scadenzaRevisione");

        $data = new stdClass();
        $data->marca = $marca;
        $data->modello = $modello;
        $data->tipologia = $tipologia;

        if ($scadenzaRevisione && $scadenzaRevisione != "") {
            $data->scadenzaRevisione = date("Y-m-d", strtotime(str_replace("/", "-", $scadenzaRevisione)));
        } else {
            $data->scadenzaRevisione = "0000-00-00";
        }

        $data->published = 1;
        $data->deleted = 0;

        if ($id) {
            $data->idAttrezzatura = $id;
            $db->updateObject('#__osma_anagrafica_attrezzature', $data, idAttrezzatura);
            $result = $db->getErrorMsg();
        } else {
            $db->insertObject('#__osma_anagrafica_attrezzature', $data, idAttrezzatura);
            $id = $db->insertid();
            $result = $db->getErrorMsg();
        }

        echo $result;
    }

}
